From 2a1b05171074a815310414a379a2f7ddcc2b5cd7 Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Wed, 3 Jul 2019 01:55:42 -0400
Subject: [PATCH 11/31] completed form of SquadDetailDefinitionUpdate

---
 .../SquadDetailDefinitionUpdateMessage.scala  | 1927 ++++++++++-------
 .../services/teamwork/SquadResponse.scala     |    2 +-
 ...uadDetailDefinitionUpdateMessageTest.scala | 1225 ++++++-----
 .../src/main/scala/WorldSessionActor.scala    |   35 +-
 4 files changed, 1901 insertions(+), 1288 deletions(-)

diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
index 62a6702e..ad080bcf 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
@@ -3,55 +3,18 @@ package net.psforever.packet.game
 
 import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
 import net.psforever.types.CertificationType
-import scodec.bits.BitVector
 import scodec.{Attempt, Codec, Err}
 import scodec.codecs._
 import shapeless.HNil
 
 import scala.annotation.tailrec
 
-final case class SquadPositionDetail(is_closed : Boolean,
-                                     role : String,
-                                     detailed_orders : String,
-                                     requirements : Set[CertificationType.Value],
-                                     char_id : Long,
-                                     name : String)
-
-final case class OldSquadDetailDefinitionUpdateMessage(guid : PlanetSideGUID,
-                                                    unk1 : Int,
-                                                    leader_char_id : Long,
-                                                    unk2 : BitVector,
-                                                    leader_name : String,
-                                                    task : String,
-                                                    zone_id : PlanetSideZoneID,
-                                                    member_info : List[SquadPositionDetail])
-
-object SquadPositionDetail {
-  final val Closed : SquadPositionDetail = SquadPositionDetail(is_closed = true, "", "", Set.empty, 0L, "")
-
-  def apply() : SquadPositionDetail = SquadPositionDetail(is_closed = false, "", "", Set.empty, 0L, "")
-
-  def apply(char_id : Long, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, "", "", Set.empty, char_id, name)
-
-  def apply(role : String, detailed_orders : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, Set.empty, 0L, "")
-
-  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value]) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, requirements, 0L, "")
-
-  def apply(role : String, detailed_orders : String, char_id : Long, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, Set.empty, char_id, name)
-
-  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value], char_id : Long, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, requirements, char_id, name)
-}
-
-object OldSquadDetailDefinitionUpdateMessage {
-  def apply(guid : PlanetSideGUID, char_id : Long, leader_name : String, task : String, zone_id : PlanetSideZoneID, member_info : List[SquadPositionDetail]) : OldSquadDetailDefinitionUpdateMessage = {
-    import scodec.bits._
-    OldSquadDetailDefinitionUpdateMessage(guid, 1, char_id, hex"000000".toBitVector, leader_name, task, zone_id, member_info)
-  }
-}
-
-//NEW FORM SquadDetailDefinitionUpdateMessage
-
-private class StreamLengthToken(init : Int = 0) {
+/**
+  * A container that should be used to keep track of the current length of a stream of bits.
+  * @param init the starting pad value;
+  *             defaults to 0
+  */
+class StreamLengthToken(init : Int = 0) {
   private var bitLength : Int = init
 
   def Length : Int = bitLength
@@ -67,14 +30,36 @@ private class StreamLengthToken(init : Int = 0) {
   }
 }
 
-final case class SquadPositionDetail2(is_closed : Option[Boolean],
-                                      role : Option[String],
-                                      detailed_orders : Option[String],
-                                      requirements : Option[Set[CertificationType.Value]],
-                                      char_id : Option[Long],
-                                      name : Option[String]) {
-  def And(info : SquadPositionDetail2) : SquadPositionDetail2 = {
-    SquadPositionDetail2(
+/**
+  * Information regarding a squad's position as a series of common fields.
+  * When parsed in an itemized way, only the important fields are represented.
+  * When parsed in a continuous manner, all of the fields are populated.
+  * All fields are optional for that reason.
+  * @param is_closed availability, whether the position can be occupied by a player;
+  *                  an unavailable position is referenced as "Closed" and no other position detail is displayed;
+  *                  an available unoccupied position is "Available"
+  * @param role the title of the position
+  * @param detailed_orders the suggested responsibilities of the position
+  * @param requirements the actual responsibilities of the position
+  * @param char_id the unique character identification number for the player that is occupying this position
+  * @param name the name of the player who is occupying this position
+  */
+final case class SquadPositionDetail(is_closed : Option[Boolean],
+                                     role : Option[String],
+                                     detailed_orders : Option[String],
+                                     requirements : Option[Set[CertificationType.Value]],
+                                     char_id : Option[Long],
+                                     name : Option[String]) {
+  /**
+    * Combine two `SquadPositionDetail` objects, with priority given to `this` one.
+    * Most fields that are not empty are assigned.
+    * Even if the current object reports the squad position being open - `is_closed = Some(false)` -
+    * just one instance of the squad position being closed overwrites all future updates.
+    * @param info the object being combined
+    * @return the combined `SquadDetail` object
+    */
+  def And(info : SquadPositionDetail) : SquadPositionDetail = {
+    SquadPositionDetail(
       is_closed match {
         case Some(false) | None =>
           info.is_closed.orElse(is_closed)
@@ -88,10 +73,69 @@ final case class SquadPositionDetail2(is_closed : Option[Boolean],
       name.orElse(info.name)
     )
   }
+
+  //methods intended to combine the fields of itself and another object
+  def Open : SquadPositionDetail =
+    this And SquadPositionDetail(Some(false), None, None, None, None, None)
+  def Close : SquadPositionDetail =
+    this And SquadPositionDetail(Some(true), None, None, None, None, None)
+  def Role(role : String) : SquadPositionDetail =
+    this And SquadPositionDetail(None, Some(role), None, None, None, None)
+  def DetailedOrders(orders : String) : SquadPositionDetail =
+    this And SquadPositionDetail(None, None, Some(orders), None, None, None)
+  def Requirements(req : Set[CertificationType.Value]) : SquadPositionDetail =
+    this And SquadPositionDetail(None, None, None, Some(req), None, None)
+  def CharId(char_id : Long) : SquadPositionDetail =
+    this And SquadPositionDetail(None, None, None, None, Some(char_id), None)
+  def Name(name : String) : SquadPositionDetail =
+    this And SquadPositionDetail(None, None, None, None, None, Some(name))
+  def Player(char_id : Long, name : String) : SquadPositionDetail =
+    this And SquadPositionDetail(None, None, None, None, Some(char_id), Some(name))
+
+  /**
+    * Complete the object by providing placeholder values for all fields.
+    * @return a `SquadPositionDetail` object with all of its field populated
+    */
+  def Complete : SquadPositionDetail = SquadPositionDetail(
+    is_closed.orElse(Some(false)),
+    role.orElse(Some("")),
+    detailed_orders.orElse(Some("")),
+    requirements.orElse(Some(Set.empty)),
+    char_id.orElse(Some(0L)),
+    name.orElse(Some(""))
+  )
 }
 
-final case class SquadPositionEntry(index : Int, info : Option[SquadPositionDetail2])
+/**
+  * A container for squad position field data
+  * associating what would be the ordinal position of that field data in full squad data.
+  * @param index the index for this squad position;
+  *              expected to be a number 0-9 or 255;
+  *              when 255, this indicated the end of enumerated squad position data and the data for that position is absent
+  * @param info the squad position field data
+  */
+final case class SquadPositionEntry(index : Int, info : Option[SquadPositionDetail])
 
+/**
+  * Information regarding a squad's position as a series of common fields.
+  * When parsed in an itemized way, only the important fields are represented.
+  * When parsed in a continuous manner, all of the fields are populated.
+  * All fields are optional for that reason.<br>
+  * <br>
+  * The squad leader does not necessarily have to be a person from the `member_info` list.
+  * @param unk1 na;
+  *             must be non-zero when parsed in a FullSquad pattern
+  * @param unk2 na;
+  *             not associated with any fields during itemized parsing
+  * @param leader_char_id he unique character identification number for the squad leader
+  * @param unk3 na
+  * @param leader_name the name of the player who is the squad leader
+  * @param task the suggested responsibilities or mission statement of the squad
+  * @param zone_id the suggested area of engagement for this squad's activities;
+  *                can also indicate the zone of the squad leader
+  * @param unk7 na
+  * @param member_info a list of squad position data
+  */
 final case class SquadDetail(unk1 : Option[Int],
                              unk2 : Option[Int],
                              leader_char_id : Option[Long],
@@ -101,6 +145,12 @@ final case class SquadDetail(unk1 : Option[Int],
                              zone_id : Option[PlanetSideZoneID],
                              unk7 : Option[Int],
                              member_info : Option[List[SquadPositionEntry]]) {
+  /**
+    * Combine two `SquadDetail` objects, with priority given to `this` one.
+    * Most fields that are not empty are assigned.
+    * @param info the object being combined
+    * @return the combined `SquadDetail` object
+    */
   def And(info : SquadDetail) : SquadDetail = {
     SquadDetail(
       unk1.orElse(info.unk1),
@@ -111,16 +161,81 @@ final case class SquadDetail(unk1 : Option[Int],
       task.orElse(info.task),
       zone_id.orElse(info.zone_id),
       unk7.orElse(info.unk7),
-      (member_info, info.member_info) match {
-        case (Some(info1), Some(info2)) => Some(info1 ++ info2)
-        case (Some(info1), _) => Some(info1)
-        case (None, Some(info2)) => Some(info2)
-        case _ => None
-      }
+      member_info.orElse(info.member_info)
     )
   }
+
+  //methods intended to combine the fields of itself and another object
+  def Field1(value : Int) : SquadDetail =
+    this And SquadDetail(Some(value), None, None, None, None, None, None, None, None)
+  def LeaderCharId(char_id : Long) : SquadDetail =
+    this And SquadDetail(None, None, Some(char_id), None, None, None, None, None, None)
+  def Field3(value : Long) : SquadDetail =
+    this And SquadDetail(None, None, None, Some(value), None, None, None, None, None)
+  def LeaderName(name : String) : SquadDetail =
+    this And SquadDetail(None, None, None, None, Some(name), None, None, None, None)
+  def Leader(char_id : Long, name : String) : SquadDetail =
+    this And SquadDetail(None, None, Some(char_id), None, Some(name), None, None, None, None)
+  def Task(task : String) : SquadDetail =
+    this And SquadDetail(None, None, None, None, None, Some(task), None, None, None)
+  def ZoneId(zone : PlanetSideZoneID) : SquadDetail =
+    this And SquadDetail(None, None, None, None, None, None, Some(zone), None, None)
+  def Field7(value : Int) : SquadDetail =
+    this And SquadDetail(None, None, None, None, None, None, None, Some(value), None)
+  def Members(list : List[SquadPositionEntry]) : SquadDetail =
+    this And SquadDetail(None, None, None, None, None, None, None, None, Some(list))
+
+  /**
+    * Complete the object by providing placeholder values for all fields.
+    * The `member_info` field requires additional allocation.
+    * @return a `SquadDetail` object with all of its field populated
+    */
+  def Complete : SquadDetail = SquadDetail(
+    unk1.orElse(Some(1)),
+    unk2.orElse(Some(0)),
+    leader_char_id.orElse(Some(0L)),
+    unk3.orElse(Some(0L)),
+    leader_name.orElse(Some("")),
+    task.orElse(Some("")),
+    zone_id.orElse(Some(PlanetSideZoneID(0))),
+    unk7.orElse(Some(0)),
+    {
+      val complete = SquadPositionDetail().Complete
+      Some(member_info match {
+        case Some(info) =>
+          //create one list that ensures all existing positions are "complete" then add a list of the missing indices
+          val fields = info.collect {
+            case SquadPositionEntry(a, Some(b)) => SquadPositionEntry(a, b.Complete)
+            case out @ SquadPositionEntry(_, None) => out
+          }
+          val indices = info.map { case SquadPositionEntry(a, _) => a }
+          ((0 to 9).toSet.diff(indices.toSet).map { SquadPositionEntry(_, complete) } ++ fields).toList.sortBy(_.index)
+        case None =>
+          //original list
+          (0 to 9).map { i => SquadPositionEntry(i, complete) }.toList
+      })
+    }
+  )
 }
 
+/**
+  * A compilation of the fields that communicate detailed information about squad structure and composition
+  * as a complement to the packet `ReplicationStreamMessage` and the packet `SquadDefinitionActionMessage`.
+  * The information communicated by the `SquadDefinitionActionMessage` packets allocates individual fields of the squad's structure
+  * and the `ReplicationStreamMessage` packet reports very surface-level information about the squad to other players.
+  * The `SquadDetailDefinitionUpdateMessage` packet serves as a realization of the field information reported by the former
+  * and a fully fleshed-out explanation of the information presented by the latter.<br>
+  * <br>
+  * Squads are generally referenced by their own non-zero globally unique identifier that is valid server-wide.
+  * A zero GUID squad is also accessible for information related to the local unpublished squad that exists on a specific client.
+  * Only one published squad can have its information displayed at a time.
+  * While imperfect squad information can be shown, two major formats for the data in this packet are common.
+  * The first format lists all of the squad's fields and data and is used as an initialization of the squad locally.
+  * This format is always used the first time information about the squad is communicated to the client.
+  * The second format lists specific portions of the squad's fields and data and is used primarily for simple updating purposes.
+  * @param guid the globally unique identifier of the squad
+  * @param detail information regarding the squad
+  */
 final case class SquadDetailDefinitionUpdateMessage(guid : PlanetSideGUID,
                                                     detail : SquadDetail)
   extends PlanetSideGamePacket {
